const U = prism.utils = prism.utils || {};

// getCD({isView: true})		// GET
// setCD({..})					// POST
// setCD({..}, {isView: true})	// PATCH
// setCD(null, {isView: true})	// DELETE

U.setCD = async (newObj, search) => {
	const rawRes = await fetch('/api/v1/custom_data' + (search ? '/query' : ''), {
		method: newObj
			? search ? 'PATCH' : 'POST'
			: 'DELETE',
		body: JSON.stringify(
			newObj && search
				? { queryForSearch: search, objectForUpdate: newObj }
				: search || newObj
		),
		headers: { 'Content-Type': 'application/json' },
	});

	return await rawRes.json();
}

U.getCD = async search => {
	const rawRes = await fetch('/api/v1/custom_data/query?query=' + JSON.stringify(search));
	return await rawRes.json();
}

U.items = function (storage) {
	var path;
	var A = []

	for (var i = 1; i < arguments.length; i++) {
		let a = arguments[i];
		let a_ = arguments[i + 1];

		if (i < 2)
			if (typeof a == 'object') {
				path = a;
				continue;
			}
			else path = [];

		if (a) {
			if (a == '-') a += '>';
			if (a[0] == '>') a = '#' + a;
		}

		let options = (a || '').split('>'); a = options.pop();
		let path_ = path.concat(a);
		let id = path_.join('>');
		let o = { caption: a };

		if (typeof a_ == 'object') {
			i++;
			o.items = U.items(storage, path_, ...a_);
		}
		else {
			let isOption = options.includes('o');
			let isButton = options.includes('#');
			let isSeparator = options.includes('-');

			const type = (() => {
				switch (true) {
					case (isOption): return 'option';
					case (isButton): return '';
					case (isSeparator): return 'separator';
					default: return 'check';
				}
			})();

			o.type = type;
			o.checked = storage[id];
			o.execute = async function () {
				let override = typeof this == 'function' && await this();
				if (!(override)) {
					if (isOption) {
						for (let item in storage)
							if (RegExp(`^${path.join('>')}>`).test(item) & storage[item] > 1)
								delete storage[item];
					}
					; (storage[id] = !storage[id]) && isOption && storage[id]++;
				}
			}.bind(typeof a_ == 'function' && ++i && a_.bind({ storage, path, o, id }))
		}

		if (o && o.type == 'separator') a = ' ';
		if (!a) continue;

		A.push(o)
	}

	return A
}

U.modal = (title, html, cb) => {
	var m = document.createElement('form');
	var currentTime = new Date().getTime();
	m.id = `modal-${currentTime}`;
	m.innerHTML = `
		<style>
			#${m.id}{
				position: absolute;
				z-index: 9999;
				left: 0;
				top: 0;
				width: 100%;
				height: 100%;
				background: rgba(0,0,0,.5);
				zoom: 1.3;
			}
			#${m.id} .popup-host{
				display:block;
				position: absolute;
				left: 50%;
				top: 50%;
				min-width: 270px;
				min-height: 170px;
				max-width: 88%;
				max-height: 88%;
				transform: translate(-50%,-50%);
			}
			#${m.id} label{
				display: block;
			}
			#${m.id} textarea,
			#${m.id} select,
			#${m.id} input{
				display: block;
				line-height: 1.2;
				font: 1em "Open Sans", Arial;
				color: #777;
				width: 100%;
				border: none;
				border-bottom: 1px solid currentColor;
			}
			#${m.id} input[type=checkbox],
			#${m.id} input[type=radio]{
				display: inline;
				color: #777;
				width: auto;
			}
			#${m.id} input[type=file]{
				position: absolute;
				left: 0;
				top: 0;
				width: 100%;
				height: 100%;
				opacity: 0;
			}
		</style>
		<div class="sis-popup-window popup-host simple">
			<div class="popup-inner">
				<div class="controller-buttons-block"><div class="dismiss"><div><i id=kill></i></div></div></div>
				<h1>${title}</h1>
				${html}
			</div>
		</div>
	`;
	document.getElementById('prism-window').appendChild(m);
	m.kill = evt => m.parentNode.removeChild(m);
	m.onclick = function (t) {
		t = t.target;
		(t == m || t.id == 'kill') && m.kill();
	}
	m.onsubmit = cb;
	m.addEventListener('submit', evt => evt.preventDefault());
	return m;
}