// 29.04.2021
// added extra "Manage Aliases" button for the filter dropdown, including its functionality

prism.run([async function() {
	await new Promise(r => setTimeout(r));
	var { setCD, getCD, modal, items } = prism.utils;
	
	function modView (widget) {
		if (widget.type != 'tablewidget' && widget.type != 'tablewidgetagg')
			return modal('Incompatible Widget Type!', '<br><br>Please use a Table or Table With Aggregation widget to create a View.');

		var m = modal(
			'Publish Widget as View',
			`
				<input name=dashboardID type=hidden value="${ widget.dashboardid }">
				<input name=widgetID    type=hidden value="${ widget.oid }">
				<br>
				<label>
					<small>View Name:</small>
					<input name=view placeholder="${ widget.title || 'Name' }" value="${ widget.title || '' }" oninput=this.form.getView()>
					<small style=display:block;min-width:30em></small>
				</label>
				<br>
				<label>
					<small>Description:</small>
					<textarea name=desc placeholder="${ widget.desc || 'Description' }">${ widget.desc || '' }</textarea>
				</label>
				<br>
				<br>
				<center>
					<button class="btn" name=save><span class="btn__text">Publish</span></button>
					<button class="btn" name=del onclick=this.form.delView(event) title="Unpublish View" style=display:none;background:red;color:#fff><span class="btn__text">Delete</span></button>
					<button class="btn btn--gray" onclick=this.form.kill()><span class="btn__text">Cancel</span></button>
				</center>
			`,
			async evt => {
				var dashboardID = m.dashboardID.value;
				var widgetID = m.widgetID.value;
				var view = m.view.value.trim().toLowerCase();
				var description = m.desc.value.trim();
				var search = { isView: true, dashboardID, widgetID }
	
				if(evt == 'del'){
					setCD(null, search)
					modal('View Unpublished', `<br>Your widget was successfuly<br>unpublished as a view:<br><br><h1 style="font:200 2.5em Helvetica;color:red">${ view }</h1>`);
					widget.style.pv = 0;
					return m.kill();
				}
	
				if(!view) return;
	
				var gotWidget = await getCD(search);   gotWidget = gotWidget[0];
				var gotView = await m.getView();
				console.log(   gotView, gotWidget   )
	
				if(!gotView || gotView.widgetID==widgetID){
					setCD({
						isView: true,
						ownerID: 'global',
						dashboardID,
						widgetID,
						view,
						description
					}, gotWidget && search)
					modal('View ' + (gotWidget ? 'Modified' : 'Published'), `<br>Your widget was successfuly<br>published as a view:<br><br><h1 style="font:200 2.5em Helvetica">${ view }</h1><hr><i>${ description }</i>`);
					m.kill();
					widget.style.pv = 1;
				}
			}
		);
	
		m.getView = async r => {
			var view = m.view.value.trim().toLowerCase();
			r = await getCD({ view, isView: true });   r = r[0];
			console.log(   view, r   );
			m.view.nextElementSibling.innerHTML = view
				? '<b style=color:' + (m.view.style.color = r ? 'red' : '#0a0') + '>' + (r ? 'Already taken' : 'Free to grab!') + '</b>'
				: '';
			return r;
		}
	
		m.delView = evt => { m.onsubmit('del'); evt.preventDefault() };
	
		(async r => {
			r = await getCD({ dashboardID: widget.dashboardid, widgetID: widget.oid });   r = r[0];
			console.log(   'r', r   );
			if(r){
				m.view.nextElementSibling.innerHTML = '<b>This widget is already published ✔️</b>';
				m.view.value = r.view        || '';
				m.desc.value = r.description || '';
				m.save.firstChild.innerHTML = 'Update';
				m.del.style.display = '';
				m.classList.add('publishedView');
			}
			else
				widget.title && m.getView();
		})();
		
		return m;
	}
	
	function linkModView (storage) {

		const m = modal('Add Link',
		`
			<br>
			<label>
				<small>Link Template:</small>
				<input name="link" placeholder="https://whatever.com/<field name>" value="${storage.Hyperlink || ''}" oninput=this.form.validateLink()>
				<small style=display:block;min-width:30em></small>
			</label>
			<br>
			<br>
			<center>
				<button class="btn" name=add onclick=this.form.addLink(this.form)><span class="btn__text">${storage.Hyperlink ? 'Change' : 'Add'}</span></button>
				<button class="btn" name=del onclick=this.form.rmLink() style="display:${storage.Hyperlink ? 'default' : 'none'};background:red;color:#fff;"><span class="btn__text">Delete</span></button>
				<button class="btn btn--gray" onclick=this.form.close()><span class="btn__text">Cancel</span></button>
			</center>	
		`);
		
		m.validateLink = () => {
			let error = /<[a-zA-Z _]+>/.test(m.link.value) ? null : 'Place at least one &lt;field name&gt; placeholder into template';
			const urlReg = /^https?:\/\/((?:[-;:&=\+\$,\w]+@)?[A-Za-z0-9.-]+|(?:www.|[-;:&=\+\$,\w]+@)[A-Za-z0-9.-]+)((?:\/[\+~%\/.\w-_]*)?\??(?:[-\+=&;%@.\w_]*)#?(?:[\w]*))?$/;
			error = error || (
				urlReg.test(m.link.value.replaceAll(/<[a-zA-Z _]+>/g, '')) ? null : 'Link should be valid URL'
			);
			m.link.nextElementSibling.style.color = error ? 'red' : 'inherit';
			m.link.nextElementSibling.innerHTML = error || '';
			return error === null;
		};

		m.addLink = ({link}) => {
			if (m.validateLink()) {
				storage.Hyperlink = link.value;
				m.kill();
			} else m.link.focus();
		};

		m.rmLink = () => {
			delete storage.Hyperlink;
			m.kill();
		};

		m.close = () => {
			m.kill();
		}
		return m;
	}
	
	prism.on('beforemenu', function(e, args) {
		var menuName = args.settings.name || 'widget';
		var dashboard = e.targetScope.dashboard;
		var widgets = dashboard.widgets.$$widgetsmap;
		var widget;
		
		if(menuName == 'dashboard'){
			args.settings.items.push({
				caption: 'Manage Views',
				execute: m => {
					m = modal(
						'Manage Dashboard Views',
						`
							<br>
							<br>
							<div id=viewList>Loading...</div>
							<br>
							<br>
							<center>
								<button class="btn btn--gray" onclick=this.form.kill()><span class="btn__text">Cancel</span></button>
							</center>
						`
					);
	
					;(async r => {
						r = await getCD({ dashboardID: dashboard.oid, isView: true });
						const buttons = (v) => `<nobr style=float:right>
										<button class="btn" name=save onclick="this.form.modView('${ v.widgetID }')"><span class="btn__text">Edit</span></button>
										<button class="btn" name=del  onclick="this.form.delView('${ v.view }')" style=background:red;color:#fff><span class="btn__text">Delete</span></button>
									  </nobr>`;
						if(r){
							viewList.innerHTML = r.sort((a, b) => a.view.localeCompare(b.view)).map(v => `
								<div>
									${prism.user.userAuth.widgets.create ? buttons(v) : ''}
									<h2>${ v.view }</h2>
									<small>${ v.description }</small>
								</div>
							`).join('<br><br>') || `<i>No views published yet.<br>Don't hesitate to do so!</i> 😎`;
						}
						else
							widget.title && m.getView();
					})();
	
					m.modView = widgetID => m.kill( modView(widgets[widgetID]) );
					m.delView = view => m.kill( setCD(null, { isView: true, view }) );
				}
			});
	
			return;
		}

		if(/widget/.test(menuName)){
			widget = e.targetScope.widget || args.settings.scope.widget;

			if(menuName == 'widget-metadataitem'){
				var {jaql} = args.settings;
				jaql.pv = jaql.pv || (jaql.filter
					? { 'Visible in View': 1 }
					: {
						'Visible in View>Yes': 2,
						'Aggregation>Count': 2,
					}
				);
				var filter = [
					'Visible in View',
					jaql.datatype == 'datetime' && 'Default Date',
					jaql.datatype === 'numeric' && 'Mod UTS',
					'-',
					'>Manage Aliases',
					function() {
						const title = 'Manage Aliases';
						const content = (`
							<style>
								.manage-aliases-modal .manage-aliases-modal__alias {
									display: flex;
									justify-content: space-between;
									align-items: center;
									width: 32%;
									padding: 3px 8px 3px 8px;
									background-color: #ffcb05;
									border-radius: 4px;
									margin-bottom: 5px;
								}

								.manage-aliases-modal .manage-aliases-modal__alias:not(:nth-of-type(3n)) {
									margin-right: 2%;
								}

								.manage-aliases-modal .manage-aliases-modal__alias-name {
									width: 88%;
									font-size: 11px;
									text-overflow: ellipsis;
									overflow: hidden;
									white-space: nowrap;
								}

								.manage-aliases-modal .manage-aliases-modal__alias-icon {
									cursor: pointer;
								}

								.manage-aliases-modal .manage-aliases-modal__button {
									height: 25.5px;
									font-size: 13px;
									border-radius: 4px;
									border: none;
									cursor: pointer;
									transition: all .3s ease;
								}
								
								.manage-aliases-modal .manage-aliases-modal__button_add {
									width: 20%;
									background-color: #ffcb05;
								}

								.manage-aliases-modal .manage-aliases-modal__button_add:hover {
									background-color: #f2b900;
								}
							</style>
							<section class="manage-aliases-modal">
								
								<br/>
								<div>
									<small style="display: block; margin-bottom: 5px;"> Create alias: </small>
									<div style="display: flex; justify-content: space-between; align-items: center;">
										<div style="width: 75%;">
											<input id="manage-aliases-modal_create-alias-input" />
											<small id="manage-aliases-modal_create-alias-error" style="color: red; font-weight: bold;"></small>
										</div>
										<button id="manage-aliases-modal_create-alias-button" class="manage-aliases-modal__button manage-aliases-modal manage-aliases-modal__button_add"> Add </button>
									</div>
								</div>
								
								<br/>
								<div>
									<small style="display: block; margin-bottom: 5px;"> Existing Aliases: </small>
									<div id="manage-aliases-modal_existing-aliases"></div>
								</div>

								<br/>
								<center>
									<button id="manage-aliases-modal_save" class="btn">
										<span class="btn__text">Save</span>
									</button>
									<button id="manage-aliases-modal_cancel" class="btn btn--gray">
										<span class="btn__text">Cancel</span>
									</button>
								</center>
							</section>
						`);

						const modalElement = modal(title, content);
						const modalHost = [...modalElement.children].find(child => [...child.classList].includes('sis-popup-window'));
						if (modalHost) {
							modalHost.style.width = '50%';
							modalHost.style.maxWidth = '420px';
						}

						const getMetadata = () => {
							const JAQLs = widget.metadata.panels.find(panel => (panel.type == 'filters')).items.map(item => item.jaql);
							return JAQLs.map(JAQL => ({
								title: JAQL.title,
								aliases: (JAQL.pv || {}).aliases || []
							}));
						}

						const updateAliases = () => {
							const html = (`
								<div style="display: flex; flex-wrap: wrap; margin-bottom: 5px;">
									${(this.storage.aliases || []).map(alias => (`
										<div class="manage-aliases-modal__alias">
											<div class="manage-aliases-modal__alias-name">${alias}</div>
											<div class="manage-aliases-modal__alias-icon">✕</div>
										</div>
									`)).join('')}
								</div>
							`);

							document.getElementById('manage-aliases-modal_existing-aliases').innerHTML = html;
							document.getElementsByClassName('manage-aliases-modal__alias-icon').forEach((element, index) => {
								element.addEventListener('click', () => {
									this.storage.aliases.splice(index, 1);
									updateAliases();
								});
							});
						}

						const setErrorMessage = (message = '') => document.getElementById('manage-aliases-modal_create-alias-error').innerHTML = message;

						updateAliases();

						const cached = this.storage.aliases ? [...this.storage.aliases] : [];
						document.getElementById('manage-aliases-modal_create-alias-button').addEventListener('click', async () => {
							const alias = document.getElementById('manage-aliases-modal_create-alias-input').value;
							if (!alias) return;

							const metadatas = getMetadata();
							const titles = metadatas.map(metadata => metadata.title);

							if ((this.storage.aliases || []).includes(alias)) return setErrorMessage(`Already taken`);

							for(const metadata of metadatas)
								if (metadata.aliases.includes(alias)) return setErrorMessage(`Already taken: there's an alias with name "${alias}" already in "${metadata.title}" filter`);

							if (titles.includes(alias)) return setErrorMessage(`Already taken: there's a filter with name "${alias}" already`);
							
							this.storage.aliases = this.storage.aliases ? [...this.storage.aliases, alias] : [alias];
							setErrorMessage();
							updateAliases();
						});
						
						document.getElementById('manage-aliases-modal_save').addEventListener('click', (event) => {
							event.preventDefault()
							modalElement.remove();
						})
						
						document.getElementById('manage-aliases-modal_cancel').addEventListener('click', (event) => {
							event.preventDefault()
							this.storage.aliases = [...cached];
							modalElement.remove();
						})
						
					}
				];
	
				var item = [
					'Visible in View', [
						'o>Yes',
						'o>No',
						'o>Show More',
					],
					'Aggregation', [
						'o>Sum',
						'o>Average',
						'o>Median',
						'o>Count',
						'o>Distinct Count',
					],
					'Default Measure',
					'Unique Identifier',
					'Header Field',
					'Hyperlink', cb
				];

				args.settings.items.push({
					caption: 'Infused View Options',
					items: [
						...items(
							jaql.pv,
							...(jaql.filter ? filter : item),
						)
					]
				});

				async function cb () {
					linkModView(this.storage);
					return true;
				}
			}
			else if (menuName == 'widget') {
				args.settings.items.push({
					caption: 'Publish as View',
					type: 'check',
					checked: widget.style.pv,
					execute: _ => widget.oid && modView(widget)
				});
			}
		}
	});
}]);
